# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           maven-compiler-plugin
Version:        2.4
Release:        2%{?dist}
Epoch:          0
Summary:        Compile project sources
Group:          Development/Libraries
License:        ASL 2.0
URL:            http://maven.apache.org/plugins/maven-compiler-plugin
# svn export http://svn.apache.org/repos/asf/maven/plugins/tags/maven-compiler-plugin-2.4 maven-compiler-plugin-2.4 && tar cjf maven-compiler-plugin-2.4.tar.bz2 maven-compiler-plugin-2.4/
Source0:        %{name}-%{version}.tar.bz2
Source1:        %{name}-jpp-depmap.xml
Patch0:         maven-compiler-plugin-pom.patch
Patch1:         maven-compiler-plugin-AbstractCompilerMojo.patch
Obsoletes:      maven2-plugin-compiler <= 0:2.0.8
Provides:       maven2-plugin-compiler = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       maven2
Requires:       jpackage-utils
Requires:       java
Requires:       plexus-compiler >= 0:1.8.1
Requires:       plexus-utils >= 0:1.5.1
BuildRequires:  java-devel
BuildRequires:  junit
BuildRequires:  maven2
BuildRequires:  maven2-common-poms
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit
%if 0
BuildRequires:  maven-plugin-testing-harness
%endif
BuildRequires:  classworlds
BuildRequires:  maven-shared-plugin-testing-harness
BuildRequires:  plexus-compiler >= 0:1.8.2
BuildRequires:  plexus-utils >= 0:1.5.1
BuildArch:      noarch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Compiler Plugin is used to compile the sources of your
project. The default compiler is javac and is used to
compile Java sources. Also note that at present the default
source setting is 1.5 and the default target setting is 1.5,
independently of the JDK you run Maven with. If you want to
change these defaults, you should set source and target as
described in Setting the -source and -target of the
Java Compiler.
Other compilers than javac can be used and work has already
started on AspectJ, .NET, and C#.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%prep
%setup -q
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1

%build
export MAVEN_OPTS="-Dproject.build.sourceEncoding=UTF-8 -Dfile.encoding=UTF-8"
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}/junit/junit/3.8.1/
ln -s $(build-classpath junit) ${MAVEN_REPO_LOCAL}/junit/junit/3.8.1/junit-3.8.1.jar
%{_bindir}/mvn-jpp \
          -e \
          -Dmaven2.jpp.depmap.file=%{SOURCE1} \
          -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
          install javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p target/maven-compiler-plugin-%{version}.jar %{buildroot}%{_javadir}/maven-compiler-plugin-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-maven-compiler-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-compiler-plugin %{version} JPP maven-compiler-plugin
if [ "x%{name}" != "xmaven-compiler-plugin" ]; then %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/maven-compiler-plugin; fi

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/maven-compiler-plugin-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/maven-compiler-plugin-%{version}
%{__ln_s} maven-compiler-plugin-%{version} %{buildroot}%{_javadocdir}/maven-compiler-plugin

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_javadir}*/maven-compiler-plugin-%{version}.jar
%{_javadir}*/maven-compiler-plugin.jar
%{_datadir}/maven2/poms/JPP-maven-compiler-plugin.pom
%{_mavendepmapfragdir}/maven-compiler-plugin

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/maven-compiler-plugin-%{version}
%{_javadocdir}/maven-compiler-plugin

%changelog
* Sat Jun 16 2012 Ralph Apel <r.apel@r-apel.de> 2.4-2
- Avoid FileDigest and PayloadIsXz problems on EL5

* Fri May 11 2012 Ralph Apel <r.apel@r-apel.de> 2.4-1
- 2.4
- Require tests to be successful

* Mon Jul 18 2011 David Walluck <dwalluck@redhat.com> 2.3-1
- 2.3
- (Build)Requires: plexus-compiler, plexus-utils

* Tue Sep 28 2010 Hui Wang <huwang@redhat.com> - 2.0.2-5
- Adjust BRs

* Wed Aug 01 2010 Hui Wang <huwang@redhat.com> - 2.0.2-4
- Rebuild with maven221
- Add commons-codec jpp depmap

* Mon Jul 19 2010 Hui Wang <huwnag@redhat.com> - 2.0.2-3
- Fixed mavenpomdir
- Fixed source compression format

* Wed May 12 2010 Alexander Kurtakov <akurtako@redhat.com> 2.0.2-2
- Add missing requires.

* Tue May 11 2010 Alexander Kurtakov <akurtako@redhat.com> 2.0.2-1
- Initial package.
